
MyArray.prototype.occurrences = function(matchFct) {
	/* occurrences(matchFct)
	Return a count (number) of the number of occurrences where
	matchFct returns true over our elements.
	e.g.,
	var a, count, matchFct
	a = new MyArray([10, 50, 10, 40, 50, 60, 10])
	count = 0
	//match if between 20 and 50 (inclusive)
	matchFct = anElem => anElem >= 20 && anElem <= 50
	println(a)
	println('occurrences between 20 and 50 (inclusive)')
	println('occurrences(matchFct): ' + a.occurrences(matchFct));
	// elements: 10,50,10,40,50,60,10
	// occurrences between 20 and 50 (inclusive)
	// occurrences(matchFct): 3
	*/
	var i, count
	i = 0
	count = 0
	while (i < this.size()) {
		var nextElem, match
		nextElem = this.get(i)
		match = matchFct(nextElem)
		if (match)
			count++
		i++
	}
	return count;
}

