
//JavaScript base code extensions

Array.prototype.add = function(newElem) {
    //default here, classes override as needed
    this.push(newElem);
}

String.prototype.capitalized = function() {
	//Note -- charAt is "soft" i.e. will return empty string for bad index
	return this.charAt(0).toUpperCase() + this.slice(1);
}

//-------------------------------------------------------------
//Comparing

Object.prototype.equals = function(other) {
    //default here, classes override as needed
    return (other != null) && this == other;
}

Object.prototype.lessThan = function(other) {
    //default here, classes override as needed
    return this < other;
}

Object.prototype.greaterThan = function(other) {
    //default here, classes override as needed
    return this > other;
}

Object.prototype.compareTo = function(other) {
	if (this.equals(other)) return 0;
	if (this.lessThan(other)) return -1;
	return 1;
}

//-------------------------------------------------------------


