
function zelem(id) { return document.getElementById(id); }
//one assistant
//let gDotOperatorAssistant = null;

/**
 * initialization when window loading is "complete"
 */
/*
document.onreadystatechange = function () {
	if (document.readyState === 'complete')
		try {
			gDotOperatorAssistant = PopupMenu.newMenu();
			gDotOperatorAssistant.registerEvents();
		} catch (ex) {
			alert('*Exception* \n' + ex.message);
		}
}
*/

class PopupMenu {

	//-----------------------------------

	constructor(controller, target, menuChoices, resultFct) {
		//target is html target elem where popup lives
		this._controller = controller;
		this._target = target;
		this._menu = menuChoices;
		this._resultFct = resultFct;
		//we need this because enter key event can trigger > 1 times
		this._pending = false;
	}

	static fromTargetMenuResult(controller, target, menuChoices, resultFct) {
		return new PopupMenu(controller, target, menuChoices, resultFct);
	}

	//-----------------------------------

	assistantElem() {
		//The "select" field
		return zelem('assistant');
	}

	containerElem() {
		//The "select" field
		return zelem('assistantContainer');
	}

	setMenu(choices) {
		this._menu = choices;
	}

	//--------------------------------------------------------------------------
	//Registeing Events

	registerEvents() {
		//false meaning we don't need advanced js "bubbling" (kis)
		/*this.assistantElem().addEventListener('keyup', this.keyupAssistant, false);
		document.addEventListener("contextmenu", this.clickedPopup);
		window.addEventListener("onclick", this.clickedWindow);*/
		this.assistantElem().addEventListener('keyup', this.handlerForName('keyupAssistant'), false);
		document.addEventListener('keyup', this.handlerForName('keyupAssistant'), false);
		//document.addEventListener('contextmenu', this.handlerForName('clickedPopup'), false);
	}

	handlerForName(handlerName) {
		//Return handler, we have to return a wrapper so handler has context to "this" (via "bind" below)
		if (!this[handlerName])
			throw `Could not find event handler method "${handlerName}"`;
		return this[handlerName + 'Wrapper'] = this[handlerName].bind(this);
	}

	//--------------------------------------------------------------------------
	//Handlers

	keyupAssistant(evt) {
		//Enter=13, Esc=27
		if (evt.keyCode === 13) {
			if (this._pending) {
				this.closePopup();
				setTimeout(() => this._resultFct.bind(this._controller)(zelem('assistant').value), 10);
			}
		} else if (evt.keyCode === 27)
			this.closePopup();
	}

	open(event) {
		this.clickedPopup(event);
	}

	clickedPopup(event) {
		event.preventDefault();
		window.addEventListener('click', this.handlerForName('clickedWindow'), false);
		const elem = this.containerElem();
		//let items = ['fee', 'fi', 'fo', 'fum'];
		//let items = this._menuFct.bind(this._controller)(this._target);
		let items = this._menu;
		this.buildMenuItems(items);
		const x = event.pageX ?? 100;
		const y = event.pagey ?? 100;
		elem.style.left = x + "px";
		elem.style.top = y + "px";
		elem.style.display = "inline-block";
		const assistElem = this.assistantElem();
		assistElem.size = items.length;
		this._pending = true;
		assistElem.focus();
	}

	clickedWindow(event) {
		//for mouse click outside of popup menu, then close popup menu
		const container = this.containerElem();
		if (container.style.display === 'none')
			return;
		const targ = event.target;
		if (container !== targ && !container.contains(targ))
			this.closePopup();

	}

	closePopup() {
		this._pending = false;
		this.containerElem().style.display = 'none';
		this.popupClosed();
	}

	//--------------------------------------------------------------------------
	//Building Menu Items

	clearMenuItems() {
		this.assistantElem().innerHTML = '';
	}

	buildMenuItems(items) {
		const select = this.assistantElem();
		this.clearMenuItems();
		items.forEach(nm => {
			let item;
			item = document.createElement("option");
			item.value = nm;
			item.innerText = nm;
			select.appendChild(item);
		});
		this.constructor.selectFirst(select);
	}

	static selectFirst(select) {
		const items = Array.from(select.options);
		if (items.length > 0)
			items[0].selected = true;
	}

	//--------------------------------------------------------------------------
	//State

	popupClosed() {
		window.removeEventListener('click', this.handlerForName('clickedWindow'), false);
	}

}

//===================================================================================================
PopupMenu;