
//framework - argument here should be name of this test case
addTestCase("AlgoLabSourceTest");

class AlgoLabSourceTest extends TestCase {

	//-----------------------------
	//Test Methods

	test_varTypeMap() {
		let src,  labSource, varTypeMap;
		src = `
			let myArray = new MyArray([10, 20, 30, 40])
			i = foo.indexOf(30)
			dump('hello')
			const a = 10
			myString = MyString.from(',')
			reversed = myString.reversed();
			`;
		labSource = new AlgoLabSource();
		labSource.source(src);

		varTypeMap = labSource.getVarTypeMap();

		this.assertEquals('MyArray', varTypeMap.get('myArray'));
		this.assertEquals('MyString', varTypeMap.get('myString'));
	}

	test_dotOperator() {
		let src, strm, labSource, type;
		src = `
			let myArray = new MyArray([10, 20, 30, 40])
			i = myArray.indexOf(30)
			dump('hello')
			const a = 10
			myString = MyString.from(',')
			reversed = myString.reversed();
			`;
		strm = new TextStream(src);
		strm.moveTo('myArray.');
		strm.moveTo('\\.');

		labSource = new AlgoLabSource();
		labSource.source(src);
		labSource.setCursorPos(strm.pos());

		type = labSource.typeAtDotOperator();
		this.assertEquals('MyArray', type);
	}

}



