
//lab.js

/*
NOTE WELL --
This script is intended for dev.
I.e., for running locally (sandboxing).
We would not want to put into production because we use Function with UI input.
*/

function getElem(nm) {
	//Return field named 'nm'
	return document.getElementById(nm);
}

document.onreadystatechange = function () {
	if(document.readyState === 'complete')
	opened();
}

function opened() {
	getElem('run').addEventListener("click", clickedRun);
	getElem('clear').addEventListener("click", clickedClear);
	inputElem().addEventListener("change", changedInput);
	inputElem().addEventListener("focus", gfInput);
	//This is important for initial (cursor) behavior in the textarea field
	inputElem().value = "";
	attachEnterKeyEvent();

	getElem('classes').addEventListener('input', changedClasses, false);
	getElem('methods').addEventListener('input', changedClasses, false);

}

function gfInput() {
	//fixupTextAreaFocus();
}

function changedInput() {
	const input = inputElem().value;
	let lines = input.split(/\r?\n/);
	lines = lines.map(line => line.trimRight());
	inputElem().value = lines.join(newline());
}

//--------------------------------------
//Getting Elements

function inputElem() {
	return getElem('input');
}

function outputElem() {
	return getElem('output');
}

//--------------------------------------
//Actions

function clickedRun() {

	const o = new MyString('foo');
	//const names = Object.getOwnPropertyNames(o);
	const names = Object.getOwnPropertyNames(MyString);
	//const names = Object.keys(MyString);
	alert(names);


	const
		selected = getSelectedInputText(),
		source = selected.length > 0 ? selected : inputElem().value,
		fct = Function(source);
	fct();
}

function clickedClear() {
	outputElem().value = "";
}

function log(text) {
	const
		elem = outputElem(),
		content = (elem.value ?? '') + '\n' + text.toString();
	elem.value = content.trimLeft();
}

function getSelectedInputText() {
	//return selected text (may be empty string)
	const
		elem = inputElem(),
		text = elem.value,
		i1 = elem.selectionStart,
		i2 = elem.selectionEnd;
	if (i1 && i2)
		return text.substring(i1, i2);
	else
		return "";
}

//-------------------------------------------------------------------
//Handling and routing enter key to "run" action

function handleEnterKey(evt) {
	// "Enter" key is 13 on keyboard
	if (evt.target.id !== "input" && evt.keyCode === 13) {
		evt.preventDefault();
		clickedRun();
	}
}

function attachEnterKeyEvent() {
	//getElem("output").addEventListener("keyup", handleEnterKey, false);
	window.addEventListener("keyup", handleEnterKey, false);
}




