
/*
PcodeParser

Pcode = Pseudocode

*/

class PcodeParser {

    constructor(src) {
        this._source = src;
        this._varTypeMap = undefined;
    }

    //-------------------------------------------------------------------
    // Access

    varTypeMap() {
        if (!this._varTypeMap)
            this._varTypeMap = this.varTypeMapBlt();
        return this._varTypeMap;
    }

    //-------------------------------------------------------------------
    // Public

    //-------------------------------------------------------------------
    // Private

    varTypeMapBlt() {
        const stringStartOrNewline = '\(\^\|\\n\)';
        const optionalVarType = '(const|let|var)?';
        const varName = '[a-zA-Z_][a-zA-Z_$0-9]*';
        const equate = '=';
        const optionalNew = '(new)?';
        const className = '[A-Z][a-zA-Z_$0-9]*';
        const pattern = `${stringStartOrNewline}\\s*${optionalVarType}\\s*${varName}\\s*${equate}\\s*${optionalNew}\\s*${className}`;
        const regex = new RegExp(pattern, 'g');
        const matches = this._source.match(regex);
        const map = new Map();
        if (!matches || matches.length === 0) return map;
        for (let matchString of matches) {
            const pair = this.constructor.parseVarTypeFrom(matchString);
            if (!pair)
                throw `parsing failed on ${matchString}`;
            map.set(pair[0], pair[1]);
        }
        return map;
    }

    //-------------------------------------------------------------------
    // Static Private

    static parseVarTypeFrom(str) {
        /* let myArray = new MyArray([10, 20, 30, 40])
            myString = MyString.from(',') */
        let strm, varName, className;
        strm = new TextStream(str);
        if (!strm.moveTo('='))
            return null;
        strm.skip(-1);
        varName = strm.prevString();
        strm.setToEnd();
        className = strm.prevString();
        return [varName, className];
    }
}


//-------------------------------------------------------------
